package init_serve

import (
	"github.com/robfig/cron/v3"
	"hongze/hongtao3_watch/global"
	"hongze/hongtao3_watch/services"
	"hongze/hongtao3_watch/watch"
)

func InitTask() {
	//services.RefreshExcel()
	c := cron.New(cron.WithSeconds())

	// 每天下午5点开始刷新excel表格
	_, err := c.AddFunc("0 0 17 * * *", services.RefreshExcel)
	//_, err := c.AddFunc("0 01 15 * * *", services.RefreshExcel)
	if err != nil {
		global.LOG.Info("RefreshExcel err" + err.Error())
	}
	c.Start()

	// 监听文件
	go watch.ListenFolderNew()

	// 处理excel
	go services.HandleFileUpdate()

	// 处理调用刷新excel的服务(调用python)
	go services.HandleRefreshExcel()

	////redis 队列刷新指标
	//go services.AutoRefresh()

	//CheckIndexCreate()
	//services.Merge()
	//yearFile="year.xlsx"

	//filePath := utils.IndexMsergeSaveDir + "season.xlsx"
	//services.DataAnalysis(filePath)

	//services.Merge()
}

//检测指标数据是否生成
//func CheckIndexCreate() {
//	var err error
//	defer func() {
//		if err != nil && err.Error() != "record not found" {
//			global.LOG.Info(utils.APPNAME + " 定时任务 出错" + time.Now().Format("2006-01-02 15:04:05") + ";Err:" + err.Error())
//			go alarm_msg.SendAlarmMsg(utils.APPNAME+" 定时任务 出错"+time.Now().Format("2006-01-02 15:04:05")+";Err:"+err.Error(), 3)
//		}
//	}()
//	err = services.IndexCreateCheck()
//}
