package services

import (
	"fmt"
	"github.com/xuri/excelize/v2"
	"strings"
	"time"
)

const (
	FormatTime    = "15:04:05" //时间格式
	FormatTimeStr = "15:04"    //时间格式
)

//var checkLock sync.RWMutex

// ReadExcel 读取Excel
func ReadExcel(filePath string) {
	time.Sleep(5 * time.Second)
	excelInfo, err := excelize.OpenFile(filePath)
	if err != nil {
		fmt.Println("OpenFile excel err:" + err.Error())
		return
	}
	fmt.Println("开始读取EXCEL了")

	defer func() {
		excelInfo.Close()
	}()

	sheetList := excelInfo.GetSheetList()

	indexNameList := make([]string, 0)
	thirdIndexIdList := make([]string, 0)
	frequencyList := make([]string, 0)
	unitList := make([]string, 0)
	//indexIdList := make([]int, 0)
	dataMap := make(map[string]map[string]string, 0)
	for _, sheet := range sheetList {
		//fmt.Println(sheet)
		sheetThirdIndexIdList := make([]string, 0)
		rows, err := excelInfo.GetRows(sheet)
		if err != nil {
			fmt.Println("err:", err)
			continue
		}

		// excel异常
		if len(rows) <= 13 {
			fmt.Println("错误的excel表")
			continue
		}
		indexLen := len(rows[0])
		//fmt.Println(indexLen)

		// 没有指标
		if indexLen <= 1 {
			fmt.Println("没有指标")
			continue
		}
		for k, row := range rows {
			//fmt.Println(row)
			// 指标信息处理
			{
				// 指标名称
				if k == 0 {
					for colIndex, col := range row {
						if colIndex == 0 {
							continue
						}
						indexNameList = append(indexNameList, col)
					}
				}

				//第三方指标id
				if k == 1 {
					for colIndex, col := range row {
						if colIndex == 0 {
							continue
						}
						thirdIndexIdList = append(thirdIndexIdList, col)
						sheetThirdIndexIdList = append(sheetThirdIndexIdList, col)
					}
				}
				//频度
				if k == 8 {
					for colIndex, col := range row {
						if colIndex == 0 {
							continue
						}
						if strings.Contains(col, "日度") {
							frequencyList = append(frequencyList, "日度")
						} else if strings.Contains(col, "周度") {
							frequencyList = append(frequencyList, "周度")
						} else if strings.Contains(col, "旬度") {
							frequencyList = append(frequencyList, "旬度")
						} else if strings.Contains(col, "月度") {
							frequencyList = append(frequencyList, "月度")
						} else if strings.Contains(col, "季度") {
							frequencyList = append(frequencyList, "季度")
						} else if strings.Contains(col, "年度") {
							frequencyList = append(frequencyList, "年度")
						} else {
							frequencyList = append(frequencyList, col)
						}
					}
				}
				//单位
				if k == 10 {
					for colIndex, col := range row {
						if colIndex == 0 {
							continue
						}
						unitList = append(unitList, col)
					}
				}
			}
			if k <= 12 {
				continue
			}

			// 数据处理
			var currDate string
			for colIndex, col := range row {
				// 数据日期
				if colIndex == 0 {
					currDate = col
					continue
				}
				// 没有数据的情况
				if col == `` {
					continue
				}
				thirdIndexId := sheetThirdIndexIdList[colIndex-1]
				if _, ok := dataMap[thirdIndexId]; !ok {
					tmpDataMap := make(map[string]string)
					dataMap[thirdIndexId] = tmpDataMap
				}
				dataMap[thirdIndexId][currDate] = col
			}

		}
	}

	// 调用指标库公共服务处理该数据
	HandleExcelDataByEdbLib(dataMap, indexNameList, thirdIndexIdList, frequencyList, unitList)
}
